Codeforces Round #369 (Div. 2) C. Coloring Trees (DP)

Coloring Trees

题目链接:

http://codeforces.com/contest/711/problem/C

Description

``` ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

</big>


 




##Input
<big>

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j's are specified even for the initially colored trees, but such trees still can't be colored.

</big>






##Output
<big>

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

</big>


 
 
##Examples
<big>

input
3 2 2
0 0 0
1 2
3 4
5 6
output
10
input
3 2 2
2 1 2
1 3
2 4
3 5
output
-1
input
3 2 2
2 0 0
1 3
2 4
3 5
output
5
input
3 2 3
2 1 2
1 3
2 4
3 5
output
0

</big>


##Note
<big>

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

</big>



<br/>
##题意:
<big>
n个树中有部分未染色,现要使得用最小代价染色完,且数串可以恰好划分为k段.
</big>


<br/>
##题解:
<big>
一开始想的dp,然后发现是O(n^4) (不过听说这也能过?),后来搞了一个优化,O(n^3)过的。
dp[i][j][k]:前i个数划分成j段且第i个数使得第k种颜色的最小花费.
考虑转移方程:
dp[i][j][k] = min(dp[i-1][j-1][k], min(dp[i-1][j-1][非k色])).
其中min(dp[i-1][j-1][非k色])如果单独求解需要额外的O(n).
所以这里额外再记录一个dp[i][j]时使用各种颜色的最小值mfirst和次小值msecond.
在dp过程中枚举颜色k后,比较k与最小值mfirst的颜色是否相同,相同则取次小值,不同则取最小值.
这样就将更新过程优化成O(1)了,注意已有颜色的数的处理.
</big>




<br/>
##代码:
``` cpp
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <vector>
#include <list>
#define LL long long
#define eps 1e-8
#define maxn 105
#define mod 100000007
#define inf 0x3f3f3f3f3f3f3f3f
#define mid(a,b) ((a+b)>>1)
#define IN freopen("in.txt","r",stdin);
using namespace std;

int n,m, bt;
int color[maxn];
LL cost[maxn][maxn];
LL dp[maxn][maxn][maxn];
typedef pair<LL,int> pii;
pii mfirst[maxn][maxn], msecond[maxn][maxn];  /*最小值 次小值*/

int main(int argc, char const *argv[])
{
    //IN;

    while(scanf("%d %d %d" ,&n,&m,&bt) != EOF)
    {
        for(int i=1; i<=n; i++)
            scanf("%d", &color[i]);

        for(int i=1; i<=n; i++) {
            for(int j=1; j<=m; j++) {
                scanf("%I64d", &cost[i][j]);
            }
            /*已有颜色,则代价为0,便于统一处理*/
            if(color[i]) cost[i][color[i]] = 0;
        }

        memset(dp, inf, sizeof(dp));
        memset(mfirst, inf, sizeof(mfirst));
        memset(msecond, inf, sizeof(msecond));

        for(int i=1; i<=m; i++) {
            dp[0][0][i] = 0;
        }
        mfirst[0][0] = make_pair(0, -1);
        msecond[0][0] = make_pair(0, -1);

        for(int i=1; i<=n; i++) {
            for(int j=1; j<=bt&&j<=i; j++) {
                LL mi_1 = inf, mi_2 = inf, p1, p2;
                for(int k=1; k<=m; k++) {
                    if(color[i] && k != color[i]) continue;  /*已有颜色,则只能更新该颜色*/

                    /* min(dp[i-1][j-1][非k色]) */
                    LL curmi = mfirst[i-1][j-1].first;
                    if(mfirst[i-1][j-1].second == k) curmi = msecond[i-1][j-1].first;

                    dp[i][j][k] = min(dp[i-1][j][k], curmi) + cost[i][k];
                    LL cur = dp[i][j][k];

                    if(cur < mi_1) {
                        mi_2 = mi_1; p2 = p1;
                        mi_1 = cur; p1 = k;
                    } else if(cur < mi_2) {
                        mi_2 = cur; p2 = k;
                    }
                }

                mfirst[i][j] = make_pair(mi_1, p1);
                msecond[i][j] = make_pair(mi_2, p2);
            }
        }

        LL ans = inf;
        for(int i=1; i<=m; i++) {
            ans = min(dp[n][bt][i], ans);
        }

        if(ans == inf) printf("-1\n");
        else printf("%I64d\n", ans);
    }

    return 0;
}
posted @ 2016-08-30 00:07  Sunshine_tcf  阅读(286)  评论(0编辑  收藏  举报